Index: trunk/src/VBox/Runtime/testcase/Makefile.kmk
===================================================================
--- trunk/src/VBox/Runtime/testcase/Makefile.kmk	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/Makefile.kmk	(revision 4071)
@@ -5,18 +5,13 @@
 
 #
-# Copyright (C) 2006-2007 innotek GmbH
-#
-# This file is part of VirtualBox Open Source Edition (OSE), as
-# available from http://www.virtualbox.org. This file is free software;
-# you can redistribute it and/or modify it under the terms of the GNU
-# General Public License as published by the Free Software Foundation,
-# in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
-# distribution. VirtualBox OSE is distributed in the hope that it will
-# be useful, but WITHOUT ANY WARRANTY of any kind.
-#
-# If you received this file as part of a commercial VirtualBox
-# distribution, then only the terms of your commercial VirtualBox
-# license agreement apply instead of the previous paragraph.
-#
+#  Copyright (C) 2006-2007 innotek GmbH
+# 
+#  This file is part of VirtualBox Open Source Edition (OSE), as
+#  available from http://www.virtualbox.org. This file is free software;
+#  you can redistribute it and/or modify it under the terms of the GNU
+#  General Public License as published by the Free Software Foundation,
+#  in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
+#  distribution. VirtualBox OSE is distributed in the hope that it will
+#  be useful, but WITHOUT ANY WARRANTY of any kind.
 
 DEPTH = ../../../..
Index: trunk/src/VBox/Runtime/testcase/ioctl.h
===================================================================
--- trunk/src/VBox/Runtime/testcase/ioctl.h	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/ioctl.h	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/ntGetTimerResolution.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/ntGetTimerResolution.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/ntGetTimerResolution.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstAvl.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstAvl.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstAvl.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstBitOperations.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstBitOperations.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstBitOperations.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstCritSect.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstCritSect.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstCritSect.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstDeadlock.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstDeadlock.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstDeadlock.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstDir-2.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstDir-2.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstDir-2.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstDir.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstDir.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstDir.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstErrUnique.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstErrUnique.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstErrUnique.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstFile.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstFile.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstFile.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstFileLock.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstFileLock.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstFileLock.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstHeapSimple.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstHeapSimple.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstHeapSimple.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstInlineAsm.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstInlineAsm.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstInlineAsm.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstIoCtl.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstIoCtl.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstIoCtl.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstLdr-2.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstLdr-2.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstLdr-2.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstLdr-3.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstLdr-3.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstLdr-3.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstLdr-4.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstLdr-4.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstLdr-4.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstLdr-4Imp-os2.def
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstLdr-4Imp-os2.def	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstLdr-4Imp-os2.def	(revision 4071)
@@ -3,18 +3,13 @@
 
 ;
-; Copyright (C) 2006-2007 innotek GmbH
-;
-; This file is part of VirtualBox Open Source Edition (OSE), as
-; available from http://www.virtualbox.org. This file is free software;
-; you can redistribute it and/or modify it under the terms of the GNU
-; General Public License as published by the Free Software Foundation,
-; in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
-; distribution. VirtualBox OSE is distributed in the hope that it will
-; be useful, but WITHOUT ANY WARRANTY of any kind.
-;
-; If you received this file as part of a commercial VirtualBox
-; distribution, then only the terms of your commercial VirtualBox
-; license agreement apply instead of the previous paragraph.
-;
+;  Copyright (C) 2006-2007 innotek GmbH
+; 
+;  This file is part of VirtualBox Open Source Edition (OSE), as
+;  available from http://www.virtualbox.org. This file is free software;
+;  you can redistribute it and/or modify it under the terms of the GNU
+;  General Public License as published by the Free Software Foundation,
+;  in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
+;  distribution. VirtualBox OSE is distributed in the hope that it will
+;  be useful, but WITHOUT ANY WARRANTY of any kind.
 
 LIBRARY tstLdr-4
Index: trunk/src/VBox/Runtime/testcase/tstLdr-4Imp-win.def
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstLdr-4Imp-win.def	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstLdr-4Imp-win.def	(revision 4071)
@@ -3,18 +3,13 @@
 
 ;
-; Copyright (C) 2006-2007 innotek GmbH
-;
-; This file is part of VirtualBox Open Source Edition (OSE), as
-; available from http://www.virtualbox.org. This file is free software;
-; you can redistribute it and/or modify it under the terms of the GNU
-; General Public License as published by the Free Software Foundation,
-; in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
-; distribution. VirtualBox OSE is distributed in the hope that it will
-; be useful, but WITHOUT ANY WARRANTY of any kind.
-;
-; If you received this file as part of a commercial VirtualBox
-; distribution, then only the terms of your commercial VirtualBox
-; license agreement apply instead of the previous paragraph.
-;
+;  Copyright (C) 2006-2007 innotek GmbH
+; 
+;  This file is part of VirtualBox Open Source Edition (OSE), as
+;  available from http://www.virtualbox.org. This file is free software;
+;  you can redistribute it and/or modify it under the terms of the GNU
+;  General Public License as published by the Free Software Foundation,
+;  in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
+;  distribution. VirtualBox OSE is distributed in the hope that it will
+;  be useful, but WITHOUT ANY WARRANTY of any kind.
 
 LIBRARY tstLdr-4
Index: trunk/src/VBox/Runtime/testcase/tstLdr.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstLdr.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstLdr.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstLdrDisasmTest.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstLdrDisasmTest.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstLdrDisasmTest.cpp	(revision 4071)
@@ -19,8 +19,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstLdrLoad.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstLdrLoad.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstLdrLoad.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstLdrObj.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstLdrObj.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstLdrObj.cpp	(revision 4071)
@@ -19,8 +19,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstLdrObjR0.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstLdrObjR0.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstLdrObjR0.cpp	(revision 4071)
@@ -19,8 +19,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstLog.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstLog.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstLog.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstMove.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstMove.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstMove.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstPath.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstPath.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstPath.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstPrfRT.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstPrfRT.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstPrfRT.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstRTFsQueries.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTFsQueries.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstRTFsQueries.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstRTProcWait.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTProcWait.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstRTProcWait.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstSems.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstSems.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstSems.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstStrFormat.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstStrFormat.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstStrFormat.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstStrToNum.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstStrToNum.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstStrToNum.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstTSC.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstTSC.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstTSC.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstTime-2.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstTime-2.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstTime-2.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstTime-3.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstTime-3.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstTime-3.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstTime.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstTime.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstTime.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstTimeSpec.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstTimeSpec.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstTimeSpec.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstTimer.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstTimer.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstTimer.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstUtf8.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstUtf8.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstUtf8.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 
Index: trunk/src/VBox/Runtime/testcase/tstUuid.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstUuid.cpp	(revision 4029)
+++ trunk/src/VBox/Runtime/testcase/tstUuid.cpp	(revision 4071)
@@ -14,8 +14,4 @@
  * distribution. VirtualBox OSE is distributed in the hope that it will
  * be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * If you received this file as part of a commercial VirtualBox
- * distribution, then only the terms of your commercial VirtualBox
- * license agreement apply instead of the previous paragraph.
  */
 