Index: trunk/src/VBox/Devices/Parallel/DevParallel.cpp
===================================================================
--- trunk/src/VBox/Devices/Parallel/DevParallel.cpp	(revision 4087)
+++ trunk/src/VBox/Devices/Parallel/DevParallel.cpp	(revision 4088)
@@ -2,4 +2,6 @@
 /** @file
  * VirtualBox Parallel Device Emulation.
+ *
+ * Contributed by: Alexander Eichner
  */
 
Index: trunk/src/VBox/Devices/Parallel/DrvHostParallel.cpp
===================================================================
--- trunk/src/VBox/Devices/Parallel/DrvHostParallel.cpp	(revision 4087)
+++ trunk/src/VBox/Devices/Parallel/DrvHostParallel.cpp	(revision 4088)
@@ -2,4 +2,6 @@
 /** @file
  * VirtualBox Host Parallel Port Driver.
+ *
+ * Contributed by: Alexander Eichner
  */
 
Index: trunk/src/VBox/Devices/Parallel/ParallelIOCtlCmd.h
===================================================================
--- trunk/src/VBox/Devices/Parallel/ParallelIOCtlCmd.h	(revision 4087)
+++ trunk/src/VBox/Devices/Parallel/ParallelIOCtlCmd.h	(revision 4088)
@@ -2,4 +2,6 @@
 /** @file
  * VBox parallel device, Private Driver IOCtls.
+ *
+ * Contributed by: Alexander Eichner
  */
 
Index: trunk/src/VBox/HostServices/SharedOpenGL/gllindrv.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedOpenGL/gllindrv.cpp	(revision 4087)
+++ trunk/src/VBox/HostServices/SharedOpenGL/gllindrv.cpp	(revision 4088)
@@ -5,5 +5,5 @@
  * Simple buffered OpenGL functions
  *
- * Contributor: Alexander Eichner
+ * Contributed by: Alexander Eichner
  */
 
@@ -34,5 +34,5 @@
  * Neccessary because Mesa and DRI cannot handle more than one
  * connection per thread (only hardware acceleration, software rendering
- * runs fine with more than one connection). 
+ * runs fine with more than one connection).
  * Would crash in vboxglDisconnect if on every vboxglConnect
  * a new Display is created */
@@ -110,5 +110,5 @@
         GLX_DOUBLEBUFFER,  GL_TRUE,  /* Request a double-buffered color buffer with */
         GLX_RED_SIZE,      1,        /* the maximum number of bits per component    */
-        GLX_GREEN_SIZE,    1, 
+        GLX_GREEN_SIZE,    1,
         GLX_BLUE_SIZE,     1,
         None
@@ -120,5 +120,5 @@
 
     /* we have to set up a rendering context to be able to use glGetString
-     * a window is created but is not mapped to screen (so it's not visible') 
+     * a window is created but is not mapped to screen (so it's not visible')
      * and a GLXContext is bound to it */
     screen_num = DefaultScreen(pClient->dpy);
@@ -151,5 +151,5 @@
 {
     /* Free all data */
-    if (pClient->enable.ctx) 
+    if (pClient->enable.ctx)
     {
         glFlush();
@@ -191,7 +191,7 @@
         if ((major == 1) && (minor >= 3)) {
             Log(("Server GLX 1.3 supported\n"));
-            pClient->glxChooseFBConfig = (PFNGLXCHOOSEFBCONFIGSGIXPROC) glXGetProcAddressARB( 
+            pClient->glxChooseFBConfig = (PFNGLXCHOOSEFBCONFIGSGIXPROC) glXGetProcAddressARB(
                                           (GLubyte *) "glXChooseFBConfig");
-            pClient->glxGetVisualFromFBConfig = (PFNGLXGETVISUALFROMFBCONFIGSGIXPROC) glXGetProcAddressARB( 
+            pClient->glxGetVisualFromFBConfig = (PFNGLXGETVISUALFROMFBCONFIGSGIXPROC) glXGetProcAddressARB(
                                                  (GLubyte *) "glXGetVisualFromFBConfig");
             pClient->glxCreateNewContext = (PFNGLXCREATECONTEXTWITHCONFIGSGIXPROC) glXGetProcAddressARB(
@@ -199,7 +199,7 @@
         } else if (vboxglCheckExtension(pClient->dpy, screenNum, "GLX_SGIX_fbconfig")) {
             Log(("GLX_SGIX_fbconfig extension supported\n"));
-            pClient->glxChooseFBConfig = (PFNGLXCHOOSEFBCONFIGSGIXPROC) glXGetProcAddressARB( 
+            pClient->glxChooseFBConfig = (PFNGLXCHOOSEFBCONFIGSGIXPROC) glXGetProcAddressARB(
                                           (GLubyte *) "glXChooseFBConfigSGIX");
-            pClient->glxGetVisualFromFBConfig = (PFNGLXGETVISUALFROMFBCONFIGSGIXPROC) glXGetProcAddressARB( 
+            pClient->glxGetVisualFromFBConfig = (PFNGLXGETVISUALFROMFBCONFIGSGIXPROC) glXGetProcAddressARB(
                                                  (GLubyte *) "glXGetVisualFromFBConfigSGIX");
             pClient->glxCreateNewContext = (PFNGLXCREATECONTEXTWITHCONFIGSGIXPROC) glXGetProcAddressARB(
@@ -271,6 +271,6 @@
 	attr.event_mask = StructureNotifyMask | ExposureMask;
 	mask = CWBackPixel | CWBorderPixel | CWColormap | CWEventMask;
-	pClient->xWindow = XCreateWindow(pClient->dpy, 
-	                                RootWindow(pClient->dpy, screen_num), 
+	pClient->xWindow = XCreateWindow(pClient->dpy,
+	                                RootWindow(pClient->dpy, screen_num),
 	                                0, 0, pClient->winWidth, pClient->winHeight, 0,
 	                                visinfo->depth, InputOutput,
@@ -382,6 +382,6 @@
 	attr.event_mask = StructureNotifyMask | ExposureMask;
 	mask = CWBackPixel | CWBorderPixel | CWColormap | CWEventMask;
-	pClient->xWindow = XCreateWindow(pClient->dpy, 
-	                                RootWindow(pClient->dpy, screen_num), 
+	pClient->xWindow = XCreateWindow(pClient->dpy,
+	                                RootWindow(pClient->dpy, screen_num),
 	                                0, 0, pClient->winWidth, pClient->winHeight, 0,
 	                                visinfo->depth, InputOutput,
@@ -534,5 +534,5 @@
         /* First get number of all visuals for the return value */
         screenNum = DefaultScreen(pClient->dpy);
-        allFBConfigs = glXGetFBConfigs(pClient->dpy, screenNum, 
+        allFBConfigs = glXGetFBConfigs(pClient->dpy, screenNum,
                                             &pClient->numFBConfigs);
         pClient->PixelFormatToFBConfigMapper = allFBConfigs;